/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2002 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome Team Members:
 *   Jean Van Wyk <jeanvanwyk@iname.com>
 *   Jeffrey S. Morgan <jeffrey.morgan@bristolwest.com>
 *   Dan Bornstein <danfuzz@milk.com>
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 *
 * This file was orriginally generated by the Java-GNOME Code Generator
 * Please do not modify the code that is identified as generated.  Also,
 * please insert your code above the generated code.
 *
 * Generation date: 2002-08-02 09:30:40 EDT
 */

package org.gnu.gtk;
import org.gnu.glib.Boxed;
/**
 *  The Clipboard object represents a clipboard of data shared between
 *  different processes or between different widgets in the same process.
 *
 * <p>TODO: This requires gdk.Selections
 * <p>TODO: callback functions
 */
public class Clipboard extends Boxed 
{
	/**
	 */
	protected Clipboard(int handle){
		this.handle = handle;
	}

	/**
	 * Clear the contents of the clipboard.
	 */
	public void clear() {
		gtk_clipboard_clear(handle);
	}
	
	/**
	 * Set the contents of the clipboard.
	 */
	public void setText(String text) {
		gtk_clipboard_set_text(handle, text, text.length());
	}
	
	/**
	 * Requests the contents of the clipboard as text.
	 */
	public String getText() {
		return gtk_clipboard_wait_for_text(handle);
	}
	
    /****************************************
     * BEGINNING OF GENERATED CODE
     ****************************************/
    native static final protected int gtk_clipboard_get (int selection);
    native static final protected int gtk_clipboard_get_display(int clipboard);
    native static final protected int gtk_clipboard_get_owner (int clipboard);
    native static final protected void gtk_clipboard_clear (int clipboard);
    native static final protected void gtk_clipboard_set_text (int clipboard, String text, int len);
    native static final protected String gtk_clipboard_wait_for_text (int clipboard);
    native static final protected boolean gtk_clipboard_wait_is_text_available (int clipboard);
    /****************************************
     * END OF GENERATED CODE
     ****************************************/
}

