/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2004 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 */

package org.gnu.gtk.event;

/**
  * This event is used to identify when a ColorButton receives an event
 * 
 * @see ColorButtonListener
 */
public class ColorButtonEvent extends GtkEvent {

	public static class Type extends GtkEventType {
		private Type(int id, String name) {
			super(id, name);
		}

		/**
		 * This event indicates that the ColorButton color selection has changed.
		 */
		public static final Type COLOR_SET = new Type(1, "COLOR_SET");

	}

	/**
	 * Constructor for ColorButtonEvent.
	 * @param source
	 * @param type
	 */
	public ColorButtonEvent(Object source, GtkEventType type) {
		super(source, type);
	}

	/**
	 * @return True if the type of this event is the same as that stated.
	 */
	public boolean isOfType(ColorButtonEvent.Type aType) {
		return (type.getID() == aType.getID());
	}
}
