/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2002 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome Team Members:
 *   Jean Van Wyk <jeanvanwyk@iname.com>
 *   Jeffrey S. Morgan <jeffrey.morgan@bristolwest.com>
 *   Dan Bornstein <danfuzz@milk.com>
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 */

package org.gnu.gtk.event;



/**
 * @author Jeffrey S. Morgan
 *
 * This is the listener interface for receiving focus events on a
 * Widget.  Objects that are interested in focus events should implement
 * this Interface and then register with the <code>Widget</code> using 
 * the <code>addFocusListener()</code> method.
 * 
 * @see FocusEvent
 */
public interface FocusListener {
	
	/**
	 * Indicates that the <code>Widget</code> has gained or lost focus
	 * 
	 * @param event The event that identifies the details of the event
	 */	
	public boolean focusEvent(FocusEvent event);
	
}
