/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2004 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 */


package org.gnu.gtk.event;

/**
  * This event is used to identify when a FontButton receives an event
 * 
 * @see FontButtonListener
 */
public class FontButtonEvent extends GtkEvent {

	public static class Type extends GtkEventType {
		private Type(int id, String name) {
			super(id, name);
		}

		/**
		 * This event indicates that the FontButtonEvent font selection has changed.
		 */
		public static final Type FONT_SET = new Type(1, "FONT_SET");
	}

	/**
	 * Constructor for FontButtonEvent.
	 * @param source
	 * @param type
	 */
	public FontButtonEvent(Object source, GtkEventType type) {
		super(source, type);
	}

	/**
	 * @return True if the type of this event is the same as that stated.
	 */
	public boolean isOfType(FontButtonEvent.Type aType) {
		return (type.getID() == aType.getID());
	}
}
