/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2002 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome Team Members:
 *   Jean Van Wyk <jeanvanwyk@iname.com>
 *   Jeffrey S. Morgan <jeffrey.morgan@bristolwest.com>
 *   Dan Bornstein <danfuzz@milk.com>
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 */

package org.gnu.gtk.event;

/**
 * An event represeting action by a {@link org.gnu.gtk.MenuItem} widget.
 * @see MenuItemListener
 * @see org.gnu.gtk.MenuItem
 */
public class MenuItemEvent extends GtkEvent {

	public static class Type extends GtkEventType{
		private Type(int id, String name){
			super(id, name);
		}

		/**
		 * This event indicates that the menu item has been activated.
		 */
		public static final Type ACTIVATE = new Type(1, "ACTIVATE");
	}

	/**
	 * Creates a new MenuItem Event. This is used internally by java-gnome. 
	 * Users only have to deal with listeners.
	 */
	public MenuItemEvent(Object source) {
		super(source, Type.ACTIVATE);
	}

}
