/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2002 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome Team Members:
 *   Jean Van Wyk <jeanvanwyk@iname.com>
 *   Jeffrey S. Morgan <jeffrey.morgan@bristolwest.com>
 *   Dan Bornstein <danfuzz@milk.com>
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 *
 * This file was orriginally generated by the Java-GNOME Code Generator
 * Please do not modify the code that is identified as generated.  Also,
 * please insert your code above the generated code.
 *
 * Generation date: 2002-07-31 13:44:41 EDT
 */

package org.gnu.pango;
import org.gnu.glib.GObject;
/**
 * Pango supports a flexible architecture where a particular rendering
 * architecture can supply an implementation of fonts. The PangoFont structure
 * represents an abstract rendering-system-indepent font. Pango provides
 * routines to list available fonts, and to load a font of a given description.
 */
public class Font extends GObject 
{

	/**
	 * Returns a description of the font.
	 */
	public FontDescription describe(){
		return new FontDescription( pango_font_describe(handle) );
	}

	/**
	 * Computes the coverage map for a given font and language tag.
	 */
	public Coverage getCoverage(Language lang){
		return new Coverage( pango_font_get_coverage(handle, lang.getHandle()) );
	}

	/**
	 * Gets overall metric information for a font. Since the metrics may be
	 * substantially different for different scripts, a language tag can be
	 * provided to indicate that the metrics should be retrieved that correspond
	 * to the script(s) used by that language.
	 */
	public FontMetrics getMetrics(Language lang){
		return new FontMetrics( pango_font_get_metrics(handle, lang.getHandle()) );
	}



    /****************************************
     * BEGINNING OF GENERATED CODE
     ****************************************/
    native static final protected int pango_font_get_type ();
    native static final protected int pango_font_describe (int font);
    native static final protected int pango_font_get_coverage (int font, int language);
    native static final protected int pango_font_get_metrics (int font, int language);
    /****************************************
     * END OF GENERATED CODE
     ****************************************/
}

